<?

function get_safe($string,$default = '',$mode = 'mysql') {
   // accepts a GET variable name in string form
   // and returns its value, safe & sanitized
   //echo stripslashes($_GET[$string]);
   $func = 'tee';
   switch ($mode) {
      case 'shell': $func = 'stripslashes'; break;
      case 'mysql':
      default: $func = 'mysql_escape_string';
   }
   return (($_GET[$string] == null) || trim($_GET[$string]) == '') ? $default
      : call_user_func($func,trim($_GET[$string]));
}

function redirect($url = 'http://www.tiptree.org') {
   header('Location: '.$url);
}

function redirect_now($url = 'http://www.tiptree.org') {
   redirect($url);
	exit;
}

function abug($array) {
   ob_start();
   print_r($array);
   $out = ob_get_contents();
   ob_end_clean();
   dbug($out);
}

function dbug($string) {
    echo '<pre><br /><br />['.$string."]\n</pre>";
}

function bbug($string) {
    echo '<div style="z-index:100;background-color:yellow;left:1px;color:red;"><pre><br /><br />['.$string."]\n</pre></div>";
}

function css_js($css = null, $js = null) {
   $out = '';
   if (isset($css) && $css && ($css != '')) $out .= '<style type="text/css">'."\n".$css."\n".'</style>'."\n";
   if (isset($js) && $js && ($js != '')) $out .= '<script type="text/javascript">'."\n<!--\n".$js."\n//\ -->\n".'</script>'."\n";
   return $out;
}

function doctype($option) {
   switch ($option) {
      case 'none':return '';
      case 'transitional':return '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/\DTD/xhtml1-transitional.dtd">';
      case 'frameset':return '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Frameset//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtm\l1-frameset.dtd">';
      case 'strict':
      default:return '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.\dtd">';
   }
}

function page($content = '', $header = '', $title = 'title', $allow_cache = false) {
   // helpful options
   //$title = 'title';
   $css = '';
   $js = '';

   // extra functionality
   $bodyproperty = ''; // for example: ' onload="func()"'

   // security
   $nospam = true;
   $allow_cache = (bool) $allow_cache;
   $bot['index'] = true;        // search engines can index? (only enable this when in production)
   $bot['archive'] = true;      // ... can archive?
   $bot['follow'] = true;        // ... can follow links? (only one I trust normally)
   $bot['imageindex'] = true;   // ... can index images?
   $bot['imageclick'] = true;   // ... can link directly to images?

   // standards
   $xhtml = 'strict'; // strict, transitional, frameset, none
   $xml = true;

   $xmltext = ($xml) ? '<?xml version="1.0" encoding="UTF-8"?>'."\n" : '';
   $htmlproperty = ($xhtml == 'strict') ? ' xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en"' : '';
   $csstext = (isset($css) && $css && $css != '') ? '<link rel="stylesheet" type="text/css" href="'.$css.'" />'."\n" : '';
   $jstext = (isset($js) && $js && $js != '') ? '<link language="javascript" type="text/javascript" src="'.$css.'"></script>'."\n" : '';
   function meta($name='',$value='',$prop1 = 'name',$prop2 = 'content') { return '<meta '.$prop1.'="'.$name.'" '.$prop2.'="'.$value.'" />'."\n"; }
   function metaq($name='',$value='') { return '<meta http-equiv="'.$name.'" content="'.$value.'" />'."\n"; }
   $nospamtext = ($nospam) ? meta('no-email-collection','http://www.unspam.com/noemailcollection') : '';
   $bottext['index'] = ($bot['index']) ? '' : 'NOINDEX';
   $bottext['archive'] = ($bot['archive']) ? '' : 'NOARCHIVE';
   $bottext['follow'] = ($bot['follow']) ? 'FOLLOW' : 'NOFOLLOW';
   $bottext['imageindex'] = ($bot['imageindex']) ? '' : 'NOIMAGEINDEX';
   $bottext['imageclick'] = ($bot['imageclick']) ? '' : 'NOIMAGECLICK';
   $count = 0;
   $bottextvalue = '';
   foreach ($bottext as $v) { if ($v != '') $count++; $bottextvalue .= ((($v != '') && ($count > 1))?',':'').$v; } unset($count);
   $bottext = ($bottextvalue != '') ? meta('robots',$bottextvalue) : '';
   $cachetext = ($allow_cache) ? '' : (metaq('Pragma','no-cache').metaq('Pragma-directive','no-cache').metaq('cache-directive','no-cache'));
   $page = $xmltext.doctype($xhtml)."\n<html".$htmlproperty.">\n<head>\n<title>".$title."</title>\n"
      .$nospamtext.$bottext.$cachetext.$csstext.$jstext."\n".$header."\n</head>\n"
      .'<body'.$bodyproperty.">\n\n".$content."\n\n</body>\n</html>";
   return $page;
}

function usable_file($FILENAME) {
	$trimmed = trim($FILENAME);
	return (
		!empty($trimmed)
	&& is_readable($FILENAME)
	&& is_file($FILENAME)
	);
}

function exclusive_get_url($array_of_strings = null ) {
   // pass an array of strings, formatted 'var=val'
   // and this returns a URL similar to the current request,
   // except any mentioned $_GET variables are
   // overriden or added.
   if (is_string($array_of_strings)) {
      $array_of_strings = array($array_of_strings);
   } elseif (!is_array($array_of_strings)) return false;

   $url = 'http://'.$_SERVER['HTTP_HOST'].$_SERVER['PHP_SELF'];
   if (!empty($array_of_strings)) $url .= '?';
   $new_array_parsed = array();
   foreach ($array_of_strings as $pair) {
      if ( (substr_count($pair,'=') == 1)
         && ($pair[0] != '=')
         && ($pair[count($pair)-1] != '=') ) {
         $temp_arr = explode('=',$pair);
         $new_array_parsed[$temp_arr[0]] = $temp_arr[1];
      }
   }
   $merged_array = array_merge($_GET,$new_array_parsed);
   foreach ($merged_array as $k => $v) {
      $url .= $k . '=' . $v . '&';
   }
   if ($url[count($url) - 1] == '&') $url = substr($url,0,-1);
   return $url;
}

function prepend_www() {
   $host = $_SERVER['HTTP_HOST'];
   if (  (substr_count($host,'.') < 2)
      && (empty($_POST))
      && (substr($_SERVER['SERVER_PROTOCOL'],0,5) == 'HTTP/')
   ) {
      redirect_now('http://www.'.$host.$_SERVER['REQUEST_URI']);
   }
}

function trusted() {
	return false;
//	return ($_SERVER['REMOTE_ADDR'] == '');
}

?>